from typing import Any, Dict
from pyspark.sql import SparkSession

from Enum.InputTypeEnum import InputTypeEnum
from Enum.CloudProviderEnum import CloudProviderEnum
from Input.BucketAwsSource import BucketAwsInput


class Input:

    def __init__(self, input_type: str, session: SparkSession, params: Dict[str, Any], provider=None) -> None:
        self.input_type = input_type
        if not provider:
            provider = CloudProviderEnum.AWS.value
        if input_type == InputTypeEnum.BUCKET.value and provider == CloudProviderEnum.AWS.value:
            self.factory = BucketAwsInput(params["identifier"], session, params)

        self.data = None

    def get_data(self) -> None:
        self.factory.get_data()
        self.data = self.factory.data

